/* main.c
 *
 * Ariel Burton
 *
 * April 2008
 *
*/

#include  <assert.h>
#include  <stdio.h>
#include  <string.h>
#include  <dlfcn.h>

typedef char *(*strdup_func_t) ( const char * );

static
void
do_exp ( const char *dlname, const char *fname, int extra_flags )
{
  void          *handle;
  char          *emesg;
  char          *s;
  strdup_func_t  f;

  handle = dlopen ( dlname, RTLD_LAZY | extra_flags );
  if ( ! handle )
    {
      emesg = dlerror ();
      printf ( "error opening %s: %s\n", dlname, emesg );
      assert ( 0 );
    }

  f = dlsym ( handle, fname );
  if ( ! f )
    {
      emesg = dlerror ();
      printf ( "error finding %s in %s: %s\n", fname, dlname, emesg );
      assert ( 0 );
    }

  printf ( "calling %s.%s\n", dlname, fname );

  s = f ( "hello world\n" );

  printf ( "back from %s.%s\n", dlname, fname );

  free ( s );

  dlclose ( handle );
} /* do_exp */

int
main ( int argc, char *argv [] )
{
  char          *s_main;

  printf ( "main: calling strdup\n" );
  s_main = strdup ( "main" );
  printf ( "main: back\n" );

  printf ( "main: do experiment with no extra flags\n" );

  do_exp ( "./f1.so", "f1", 0 );

  printf ( "main: doing experiment with RTLD_DEEPBIND\n" );

  do_exp ( "./f1.so", "f1", RTLD_DEEPBIND );

  return 0;
}

