/* strdup_ia.c
 *
 * Ariel Burton
 *
 * April 2008
 *
*/


#include  <assert.h>
#include  <string.h>
#include  <stdlib.h>
#include  <dlfcn.h>

static int mesg_fd  = 1;

static char  *(*strdup_fp) ( const char * );

static
void
put_string ( int fd, char *s )
{
  size_t  len = strlen ( s );

  write ( fd, s, len );
} /* put_string */

static
void
find_target ( char *sym, void **p )
{
  *p = dlsym ( RTLD_NEXT, sym );
}

char *
strdup ( const char *s )
{
  char   *ret_val;

  put_string ( 1, "++++ entering interposing strdup\n" );

  if ( ! strdup_fp )
    {
      find_target ( "strdup", (void **) &strdup_fp );
      assert ( strdup_fp );
    }

  ret_val = strdup_fp ( s );

  put_string ( 1, "++++ leaving interposing strdup\n" );

  return ret_val;
} /* strdup */

